<?php
/**
 * MySQL Functions
 *
 * This is the MYSQL Database Connection Module, it is called up when where the database needs connected to.
 * This include the functions to query the database.
 * There are sections with !!!!!!!!!!!!! SQL QUERY HERE !!!!!!!!!!!! commented on the end of the query, this is so it can be found easily.
 *
 **/
 
/**
 * Connect to the database but check the values before hand. Please note, the output $handle isn't always correct for some reason.
 **/
function db_connect(){
require('config/database.config.php');
    $server = $MYSQL['server'];
    $name = $MYSQL['username'];
    $pass = $MYSQL['password'];
  // Some checks on the variables being passed
    $server = filter_var($server, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
    $server = filter_var($server, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
    $name = filter_var($name, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
    $name = filter_var($name, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
    $pass = filter_var($pass, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
    $pass = filter_var($pass, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
  $handle = mysql_connect($server,$name,$pass);
  return $handle;
}

/**
 * Find the number of closed problems (displayed on the footer by default)
 **/
function db_problems_total_closed($dbcon=NULL){
require('config/database.config.php');
    $db = $MYSQL['db'];
  // Some checks on the variables being passed
    $db = filter_var($db, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
    $db = filter_var($db, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
  // Prefix checking (If enabled)
	if((isset($MYSQL['prefix']))||($MYSQL['prefix']!="")){
		$prefix = $MYSQL['prefix'];
		$prefix = filter_var($prefix, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
		$prefix = filter_var($prefix, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
	}else{
		$prefix="";
	}
  // Check to see if connection is alive
    if ((!@mysql_ping($dbcon))||($dbcon==NULL)){
		$dbcon = db_connect();
	}
	$db = mysql_select_db($db,$dbcon);
	$query = "SELECT count(*) FROM ".$prefix."question WHERE `status` = \"2\""; // !!!!!!!!!!!!! SQL QUERY HERE !!!!!!!!!!!!
	$result = @mysql_query($query);
	if (!$result){
		logger("MySQL Error","db_problems_total_closed","Database Returned Error - ".mysql_error());
		return 0;
	}
	while($row = @mysql_fetch_array($result)){
		$total = $row['count(*)'];
	}
	mysql_close();
  return $total;
}

/**
 * ExpressFind™ a problem, this returns the "question" id.
 **/
function db_expressfind($efcode,$dbcon=NULL){
require('config/database.config.php');
    $db = $MYSQL['db'];
  // Some checks on the variables being passed
    $db = filter_var($db, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
    $db = filter_var($db, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
	$efcode = filter_var($efcode, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
    $efcode = filter_var($efcode, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
  // Prefix checking (If enabled)
	if((isset($MYSQL['prefix']))||($MYSQL['prefix']!="")){
		$prefix = $MYSQL['prefix'];
		$prefix = filter_var($prefix, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
		$prefix = filter_var($prefix, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
	}else{
		$prefix="";
	}
  // Check to see if connection is alive
    if ((!@mysql_ping($dbcon))||($dbcon==NULL)){
		$dbcon = db_connect();
	}
	$db = mysql_select_db($db,$dbcon);
	$query = "SELECT id FROM ".$prefix."question WHERE `efcode` = \"".$efcode."\""; // !!!!!!!!!!!!! SQL QUERY HERE !!!!!!!!!!!!
	$result = @mysql_query($query);
	if (!$result){
		logger("MySQL Error","db_expressfind","Database Returned Error - ".mysql_error());
		return 0;
	}
	while($row = @mysql_fetch_array($result)){
		$id = $row['id'];
	}
	mysql_close();
  return $id;
}

/**
 * Retreieve a question and dump the output into an array from a question id
 *
 *  Array
 *   {
 *	  	[id]		=> 0123456789
 *	  	[sid]		=> 012345678					// Student ID
 *	  	[timestamp]	=> 012345678901					// POSIX Timestamp from PHP
 *	  	[question]	=> Blah blah blah blah blah		// This is upto 5000 Characters.
 *	  	[file]		=> foobar.jpg
 *	  	[dept]		=> 10							// Department ID from the department table
 *	  	[status]	=> Pending						// Either Open, Pending or Closed
 *	  	[priority]	=> 2							// This returns either 0 = Normal, 1 = User High, 2 = Staff High or 3 = Low
 *	  	[efcode]	=> EFQ09DZ765DE					// A second unique code, Currently the structure is not developed
 *	  	[faq]	=> 1								// The FAQ Flag
 *   }
 *   Returns FALSE on error and logs.
 **/
function db_problems_retrieve($id,$dbcon=NULL){
require('config/database.config.php');
    $db = $MYSQL['db'];
  // Some checks on the variables being passed
    $db = filter_var($db, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
    $db = filter_var($db, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
  // Prefix checking (If enabled)
	if((isset($MYSQL['prefix']))||($MYSQL['prefix']!="")){
		$prefix = $MYSQL['prefix'];
		$prefix = filter_var($prefix, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
		$prefix = filter_var($prefix, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
	}else{
		$prefix="";
	}
  // Check to see if connection is alive
    if ((!@mysql_ping($dbcon))||($dbcon==NULL)){
		$dbcon = db_connect();
	}
	$db = mysql_select_db($db,$dbcon);
	$query = "SELECT * FROM ".$prefix."question WHERE `id` = \"".$id."\""; // !!!!!!!!!!!!! SQL QUERY HERE !!!!!!!!!!!!
	$result = @mysql_query($query);
	if (!$result){
		logger("MySQL Error","db_problems_retrieve","Database Returned Error - ".mysql_error());
		return 0;
	}
    while($row = @mysql_fetch_array($result)){
		$quest['id'] = $row['id'];
		$quest['sid'] = $row['sid'];
		$quest['time'] = $row['timestamp'];
		$quest['question'] = $row['question'];
		$quest['file'] = $row['file'];
		$quest['dept'] = $row['dept'];
		$quest['status'] = $row['status'];
		$quest['priority'] = $row['priority'];
		$quest['efcode'] = $row['efcode'];
		$quest['faq'] = $row['faq'];
	}
	mysql_close();
	return $quest;
}

/**
 * Retreieve response ID and dump the output into an array from a question id
 *
 *  Array
 *   {
 *	  	[id][x]	=> 0123456789
 *   }
 *   Returns FALSE on error and logs.
 **/
function db_response_id_retrieve($qid,$dbcon=NULL){
require('config/database.config.php');
    $db = $MYSQL['db'];
  // Some checks on the variables being passed
    $db = filter_var($db, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
    $db = filter_var($db, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
  // Prefix checking (If enabled)
	if((isset($MYSQL['prefix']))||($MYSQL['prefix']!="")){
		$prefix = $MYSQL['prefix'];
		$prefix = filter_var($prefix, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
		$prefix = filter_var($prefix, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
	}else{
		$prefix="";
	}
  // Check to see if connection is alive
    if ((!@mysql_ping($dbcon))||($dbcon==NULL)){
		$dbcon = db_connect();
	}
	$db = mysql_select_db($db,$dbcon);
	$query = "SELECT id FROM ".$prefix."response WHERE `qid` = \"".$qid."\" ORDER BY timestamp ASC"; // !!!!!!!!!!!!! SQL QUERY HERE !!!!!!!!!!!!
	$result = @mysql_query($query);
	if (!$result){
		logger("MySQL Error","db_response_id_retrieve","Database Returned Error - ".mysql_error());
		return 0;
	}
    while($row = @mysql_fetch_array($result)){
		$res['id'][] = $row['id'];
	}
	mysql_close();
	return $res;
}

/**
 * Retreieve response and dump the output into an array from a response id
 *
 *  Array
 *   {
 *	  	[id]			=> 0123456789
 *	  	[qid]			=> 0123456789
 *	  	[timestamp]		=> 012345678901					// POSIX timestamp from PHP fucntion
 *	  	[usertype]		=> S							// S = Staff,U = Student
 *	  	[userid]		=> 012345678
 *	  	[file]			=> foobar.jpg
 *	  	[response]		=> Blah blah blah blah blah		// This is upto 5000 Characters.
 *   }
 *   Returns FALSE on error and logs.
 **/
function db_response_retrieve($id,$dbcon=NULL){
require('config/database.config.php');
    $db = $MYSQL['db'];
  // Some checks on the variables being passed
    $db = filter_var($db, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
    $db = filter_var($db, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
  // Prefix checking (If enabled)
	if((isset($MYSQL['prefix']))||($MYSQL['prefix']!="")){
		$prefix = $MYSQL['prefix'];
		$prefix = filter_var($prefix, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
		$prefix = filter_var($prefix, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
	}else{
		$prefix="";
	}
  // Check to see if connection is alive
    if ((!@mysql_ping($dbcon))||($dbcon==NULL)){
		$dbcon = db_connect();
	}
	$db = mysql_select_db($db,$dbcon);
	$query = "SELECT * FROM ".$prefix."response WHERE `id` = \"".$id."\""; // !!!!!!!!!!!!! SQL QUERY HERE !!!!!!!!!!!!
	$result = @mysql_query($query);
	if (!$result){
		logger("MySQL Error","db_response_retrieve","Database Returned Error - ".mysql_error());
		return 0;
	}
  while($row = @mysql_fetch_array($result)){
		$res['id'] = $row['id'];
		$res['qid'] = $row['qid'];
		$res['time'] = $row['timestamp'];
		$res['usertype'] = $row['usertype'];
		$res['userid'] = $row['userid'];
		$res['file'] = $row['file'];
		$res['response'] = $row['response'];
	}
	mysql_close();
	return $res;
}


/**
 * Retrieve Departments
 *
 * Returns the Department Name
 * Returns FALSE on error and logs.
 **/
function db_dept_retrieve($id,$dbcon=NULL){
require('config/database.config.php');
    $db = $MYSQL['db'];
  // Some checks on the variables being passed
    $db = filter_var($db, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
    $db = filter_var($db, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
  // Prefix checking (If enabled)
	if((isset($MYSQL['prefix']))||($MYSQL['prefix']!="")){
		$prefix = $MYSQL['prefix'];
		$prefix = filter_var($prefix, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
		$prefix = filter_var($prefix, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
	}else{
		$prefix="";
	}
  // Check to see if connection is alive
    if ((!@mysql_ping($dbcon))||($dbcon==NULL)){
		$dbcon = db_connect();
	}
	$db = mysql_select_db($db,$dbcon);
	$query = "SELECT dept FROM ".$prefix."departments WHERE `id` = \"".$id."\""; // !!!!!!!!!!!!! SQL QUERY HERE !!!!!!!!!!!!
	$result = @mysql_query($query);
	if (!$result){
		logger("MySQL Error","db_dept_retrieve","Database Returned Error - ".mysql_error());
		return 0;
	}
	while($row = @mysql_fetch_array($result)){
		$dept = $row['dept'];
	}
	mysql_close();
  return $dept;
}


/**
 * Retrieve full name
 *
 *  Mr. Adam Boutch
 *  Returns FALSE on error and logs.
 **/
function get_user_name($id,$type,$dbcon=NULL){
require('config/database.config.php');
	$db = $MYSQL['db'];
  // Some checks on the variables being passed
    $db = filter_var($db, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
    $db = filter_var($db, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
  // Prefix checking (If enabled)
	if((isset($MYSQL['prefix']))||($MYSQL['prefix']!="")){
		$prefix = $MYSQL['prefix'];
		$prefix = filter_var($prefix, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
		$prefix = filter_var($prefix, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
	}else{
		$prefix="";
	}
  // Check to see if connection is alive
    if ((!@mysql_ping($dbcon))||($dbcon==NULL)){
		$dbcon = db_connect();
	}
	$db = mysql_select_db($db,$dbcon);
	
	if(($type == 1)||($type == "1")||(strtoupper($type) == "U")){
		$query = "SELECT title, fname, sname FROM ".$prefix."student WHERE `id` = \"".$id."\""; // !!!!!!!!!!!!! SQL QUERY HERE !!!!!!!!!!!!
	}elseif(($type == 2)||($type == "2")||(strtoupper($type) == "S")){
		$query = "SELECT title, fname, sname FROM ".$prefix."staff WHERE `id` = \"".$id."\""; // !!!!!!!!!!!!! SQL QUERY HERE !!!!!!!!!!!!
	}else{
		logger("User","get_user_name","Incorrect \$type given; ".$type." .");
		logger("Sec","get_user_name","Incorrect \$type given; ".$type." .");
		logger("Debug","get_user_name","Incorrect \$type given; ".$type." .");
		return 0;
	}
	$result = @mysql_query($query);
	if (!$result){
		logger("MySQL Error","get_user_name","Database Returned Error - ".mysql_error());
		return 0;
	}
 	while($row = @mysql_fetch_array($result)){
		$person['title'] = $row['title'];
		$person['fname'] = $row['fname'];
		$person['sname'] = $row['sname'];
	}
	$fullperson = $person['title'].". ".$person['fname']." ".$person['sname'];
	mysql_close();
	return $fullperson;
}


/**
 * Retrieves first name
 *
 *  Adam
 *  Returns FALSE on error and logs.
 **/
function get_user_name_informal($id,$type,$dbcon=NULL){
require('config/database.config.php');
	$db = $MYSQL['db'];
  // Some checks on the variables being passed
    $db = filter_var($db, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
    $db = filter_var($db, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
  // Prefix checking (If enabled)
	if((isset($MYSQL['prefix']))||($MYSQL['prefix']!="")){
		$prefix = $MYSQL['prefix'];
		$prefix = filter_var($prefix, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
		$prefix = filter_var($prefix, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
	}else{
		$prefix="";
	}
  // Check to see if connection is alive
    if ((!@mysql_ping($dbcon))||($dbcon==NULL)){
		$dbcon = db_connect();
	}
	$db = mysql_select_db($db,$dbcon);
	
	if(($type == 1)||($type == "1")||(strtoupper($type) == "U")){
		$query = "SELECT fname FROM ".$prefix."student WHERE `id` = \"".$id."\""; // !!!!!!!!!!!!! SQL QUERY HERE !!!!!!!!!!!!
	}elseif(($type == 2)||($type == "2")||(strtoupper($type) == "S")){
		$query = "SELECT fname FROM ".$prefix."staff WHERE `id` = \"".$id."\""; // !!!!!!!!!!!!! SQL QUERY HERE !!!!!!!!!!!!
	}else{
		logger("User","get_user_name_informal","Incorrect \$type given; ".$type." .");
		logger("Sec","get_user_name_informal","Incorrect \$type given; ".$type." .");
		logger("Debug","get_user_name_informal","Incorrect \$type given; ".$type." .");
		return 0;
	}
	$result = @mysql_query($query);
	if (!$result){
		logger("MySQL Error","get_user_name_informal","Database Returned Error - ".mysql_error());
		return 0;
	}
 	while($row = @mysql_fetch_array($result)){
		$person['fname'] = $row['fname'];
	}
	$fullperson = $person['fname'];
	mysql_close();
	return $fullperson;
}

/**
 * Gets the number of questions associated with the User ID
 *
 *  returns a number
 *  Returns FALSE on error and logs.
 **/
function db_problems_total_id($uid,$dbcon=NULL){
require('config/database.config.php');
    $db = $MYSQL['db'];
  // Some checks on the variables being passed
    $db = filter_var($db, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
    $db = filter_var($db, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
  // Prefix checking (If enabled)
	if((isset($MYSQL['prefix']))||($MYSQL['prefix']!="")){
		$prefix = $MYSQL['prefix'];
		$prefix = filter_var($prefix, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
		$prefix = filter_var($prefix, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
	}else{
		$prefix="";
	}
  // Check to see if connection is alive
    if ((!@mysql_ping($dbcon))||($dbcon==NULL)){
		$dbcon = db_connect();
	}
	$db = mysql_select_db($db,$dbcon);
	$query = "SELECT count(*) FROM ".$prefix."question WHERE `sid` = \"".$uid."\""; // !!!!!!!!!!!!! SQL QUERY HERE !!!!!!!!!!!!
	$result = @mysql_query($query);
	if (!$result){
		logger("MySQL Error","db_problems_total_id","Database Returned Error - ".mysql_error());
		return 0;
	}
    while($row = @mysql_fetch_array($result)){
		$count = $row['count(*)'];
	}
	mysql_close();
	return $count;
}


/**
 * Gets the number of questions associated with the User ID that are closed
 *
 *  returns a number
 *  Returns FALSE on error and logs.
 **/
function db_problems_total_id_closed($uid,$dbcon=NULL){
require('config/database.config.php');
    $db = $MYSQL['db'];
  // Some checks on the variables being passed
    $db = filter_var($db, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
    $db = filter_var($db, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
  // Prefix checking (If enabled)
	if((isset($MYSQL['prefix']))||($MYSQL['prefix']!="")){
		$prefix = $MYSQL['prefix'];
		$prefix = filter_var($prefix, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
		$prefix = filter_var($prefix, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
	}else{
		$prefix="";
	}
  // Check to see if connection is alive
    if ((!@mysql_ping($dbcon))||($dbcon==NULL)){
		$dbcon = db_connect();
	}
	$db = mysql_select_db($db,$dbcon);
	$query = "SELECT count(*) FROM ".$prefix."question WHERE `sid` = \"".$uid."\" AND `status` = \"2\""; // !!!!!!!!!!!!! SQL QUERY HERE !!!!!!!!!!!!
	$result = @mysql_query($query);
	if (!$result){
		logger("MySQL Error","db_problems_total_id_closed","Database Returned Error - ".mysql_error());
		return 0;
	}
    while($row = @mysql_fetch_array($result)){
		$count = $row['count(*)'];
	}
	mysql_close();
	return $count;
}

/**
 * Retreieve a question id from the user ID
 *
 *  Array
 *   {
 *	  	[id][x]		=> 0123456789
 *   }
 *   Returns FALSE on error and logs.
 **/
function db_problems_id_retrieve($id,$dbcon=NULL){
require('config/database.config.php');
    $db = $MYSQL['db'];
  // Some checks on the variables being passed
    $db = filter_var($db, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
    $db = filter_var($db, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
  // Prefix checking (If enabled)
	if((isset($MYSQL['prefix']))||($MYSQL['prefix']!="")){
		$prefix = $MYSQL['prefix'];
		$prefix = filter_var($prefix, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
		$prefix = filter_var($prefix, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
	}else{
		$prefix="";
	}
  // Check to see if connection is alive
    if ((!@mysql_ping($dbcon))||($dbcon==NULL)){
		$dbcon = db_connect();
	}
	$db = mysql_select_db($db,$dbcon);
	$query = "SELECT * FROM ".$prefix."question WHERE `sid` = \"".$id."\" ORDER BY status ASC, priority DESC,timestamp DESC"; // !!!!!!!!!!!!! SQL QUERY HERE !!!!!!!!!!!!
	$result = @mysql_query($query);
	if (!$result){
		logger("MySQL Error","db_problems_id_retrieve","Database Returned Error - ".mysql_error());
		return 0;
	}
    while($row = @mysql_fetch_array($result)){
		$quest['id'][] = $row['id'];
	}
	mysql_close();
	return $quest;
}


/**
 * Reply to a particular question
 *
 *   Returns FALSE on error and logs.
 **/
function db_respond($qid,$message,$file,$uid,$utype,$dbcon=NULL){
require('config/database.config.php');
    $db = $MYSQL['db'];
  // Some checks on the variables being passed
    $db = filter_var($db, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
    $db = filter_var($db, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
    $message = htmlspecialchars($message);
    $utype=user_type_change($utype);
  // Prefix checking (If enabled)
	if((isset($MYSQL['prefix']))||($MYSQL['prefix']!="")){
		$prefix = $MYSQL['prefix'];
		$prefix = filter_var($prefix, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
		$prefix = filter_var($prefix, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
	}else{
		$prefix="";
	}
  // Check to see if connection is alive
    if ((!@mysql_ping($dbcon))||($dbcon==NULL)){
		$dbcon = db_connect();
	}
	$db = mysql_select_db($db,$dbcon);
	$query = "INSERT INTO ".$prefix."response (`id`, `qid`, `timestamp`, `usertype`, `userid`, `file`, `response`) VALUES (NULL, '".$qid."', '".time()."', '".$utype."', '".$uid."', '".$file."', '".$message."');"; // !!!!!!!!!!!!! SQL QUERY HERE !!!!!!!!!!!!
	$result = @mysql_query($query);
	if (!$result){
		logger("MySQL Error","db_respond","Database Returned Error - ".mysql_error());
		return 0;
	}
	mysql_close();
	return TRUE;
}

/**
 * Retrieve School
 *
 * Returns the School Name and dept ID.
 *  Array
 *   {
 *	  	[dept]			=> 11
 *	  	[name]			=> School of Computing
 *	 }
 * Returns FALSE on error and logs.
 **/
function db_school_retrieve($id,$dbcon=NULL){
require('config/database.config.php');
    $db = $MYSQL['db'];
  // Some checks on the variables being passed
    $db = filter_var($db, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
    $db = filter_var($db, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
  // Prefix checking (If enabled)
	if((isset($MYSQL['prefix']))||($MYSQL['prefix']!="")){
		$prefix = $MYSQL['prefix'];
		$prefix = filter_var($prefix, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
		$prefix = filter_var($prefix, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
	}else{
		$prefix="";
	}
  // Check to see if connection is alive
    if ((!@mysql_ping($dbcon))||($dbcon==NULL)){
		$dbcon = db_connect();
	}
	$db = mysql_select_db($db,$dbcon);
	$query = "SELECT * FROM ".$prefix."school WHERE `id` = \"".$id."\""; // !!!!!!!!!!!!! SQL QUERY HERE !!!!!!!!!!!!
	$result = @mysql_query($query);
	if (!$result){
		logger("MySQL Error","db_school_retrieve","Database Returned Error - ".mysql_error());
		return 0;
	}
	while($row = @mysql_fetch_array($result)){
		$school['dept'] = $row['deptid'];
		$school['name'] = $row['name'];
	}
	mysql_close();
  return $school;
}


/**
 * Retreieve open and pending question ids from the School(Dept in the database) ID
 *
 *  Array
 *   {
 *	  	[id][x]		=> 0123456789
 *   }
 *   Returns FALSE on error and logs.
 **/
function db_problems_school_retrieve($schoolid,$dbcon=NULL){
require('config/database.config.php');
    $db = $MYSQL['db'];
  // Some checks on the variables being passed
    $db = filter_var($db, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
    $db = filter_var($db, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
  // Prefix checking (If enabled)
	if((isset($MYSQL['prefix']))||($MYSQL['prefix']!="")){
		$prefix = $MYSQL['prefix'];
		$prefix = filter_var($prefix, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
		$prefix = filter_var($prefix, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
	}else{
		$prefix="";
	}
  // Check to see if connection is alive
    if ((!@mysql_ping($dbcon))||($dbcon==NULL)){
		$dbcon = db_connect();
	}
	$db = mysql_select_db($db,$dbcon);
	$query = "SELECT * FROM ".$prefix."question WHERE `dept` = \"".$schoolid."\" AND `status` <> \"2\" ORDER BY priority DESC,timestamp DESC"; // !!!!!!!!!!!!! SQL QUERY HERE !!!!!!!!!!!!
	$result = @mysql_query($query);
	if (!$result){
		logger("MySQL Error","db_problems_school_retrieve","Database Returned Error - ".mysql_error());
		return 0;
	}
    while($row = @mysql_fetch_array($result)){
		$quest['id'][] = $row['id'];
	}
	mysql_close();
	return $quest;
}


/**
 * Retreieve closed question ids from the School(Dept in the database) ID
 *
 *  Array
 *   {
 *	  	[id][x]		=> 0123456789
 *   }
 *   Returns FALSE on error and logs.
 **/
function db_problems_school_retrieve_closed($schoolid,$dbcon=NULL){
require('config/database.config.php');
    $db = $MYSQL['db'];
  // Some checks on the variables being passed
    $db = filter_var($db, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
    $db = filter_var($db, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
  // Prefix checking (If enabled)
	if((isset($MYSQL['prefix']))||($MYSQL['prefix']!="")){
		$prefix = $MYSQL['prefix'];
		$prefix = filter_var($prefix, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
		$prefix = filter_var($prefix, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
	}else{
		$prefix="";
	}
  // Check to see if connection is alive
    if ((!@mysql_ping($dbcon))||($dbcon==NULL)){
		$dbcon = db_connect();
	}
	$db = mysql_select_db($db,$dbcon);
	$query = "SELECT * FROM ".$prefix."question WHERE `dept` = \"".$schoolid."\" AND `status` = \"2\" ORDER BY priority ASC,timestamp DESC"; // !!!!!!!!!!!!! SQL QUERY HERE !!!!!!!!!!!!
	$result = @mysql_query($query);
	if (!$result){
		logger("MySQL Error","db_problems_school_retrieve","Database Returned Error - ".mysql_error());
		return 0;
	}
    while($row = @mysql_fetch_array($result)){
		$quest['id'][] = $row['id'];
	}
	mysql_close();
	return $quest;
}


/**
 * New Question
 *
 *   Returns FALSE on error and logs.
 **/
function db_question($sid,$message,$file,$ef,$priority,$school,$dbcon=NULL){
require('config/database.config.php');
    $db = $MYSQL['db'];
  // Some checks on the variables being passed
    $db = filter_var($db, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
    $db = filter_var($db, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
    $message = htmlspecialchars($message);
  // Prefix checking (If enabled)
	if((isset($MYSQL['prefix']))||($MYSQL['prefix']!="")){
		$prefix = $MYSQL['prefix'];
		$prefix = filter_var($prefix, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
		$prefix = filter_var($prefix, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
	}else{
		$prefix="";
	}
  // Check to see if connection is alive
    if ((!@mysql_ping($dbcon))||($dbcon==NULL)){
		$dbcon = db_connect();
	}
	$db = mysql_select_db($db,$dbcon);
	$query = "INSERT INTO ".$prefix."question (`id`, `sid`, `timestamp`, `question`, `file`, `dept`, `status`, `priority`, `efcode`, `faq`) VALUES (NULL, '".$sid."', '".time()."', '".$message."', '".$file."', '".$school."', '0', '".$priority."', '".$ef."', '0');"; // !!!!!!!!!!!!! SQL QUERY HERE !!!!!!!!!!!!
	$result = @mysql_query($query);
	if (!$result){
		logger("MySQL Error","db_question","Database Returned Error - ".mysql_error());
		return 0;
	}
		logger("ExpressFind","db_question","ExpressFind Code: ".$ef." is now in use.");
		mysql_close();
	return TRUE;
}


/**
 * Open/Close a Question
 *
 *   Returns FALSE on error and logs.
 **/
function db_status_question($qid,$status,$dbcon=NULL){
require('config/database.config.php');
    $db = $MYSQL['db'];
  // Some checks on the variables being passed
    $db = filter_var($db, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
    $db = filter_var($db, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
  // Prefix checking (If enabled)
	if((isset($MYSQL['prefix']))||($MYSQL['prefix']!="")){
		$prefix = $MYSQL['prefix'];
		$prefix = filter_var($prefix, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
		$prefix = filter_var($prefix, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
	}else{
		$prefix="";
	}
	$status_orig = status_text($status);
  // Check to see if connection is alive
    if ((!@mysql_ping($dbcon))||($dbcon==NULL)){
		$dbcon = db_connect();
	}
	$db = mysql_select_db($db,$dbcon);
	$query = "UPDATE ".$prefix."question SET `status` = '".$status."'WHERE `id` =".$qid.";"; // !!!!!!!!!!!!! SQL QUERY HERE !!!!!!!!!!!!
	$result = @mysql_query($query);
	if (!$result){
		logger("MySQL Error","db_status_question","Database Returned Error - ".mysql_error());
		return 0;
	}
		logger("Status Change","db_status_question","Question id: ".$qid." is now ".$status_orig);
	mysql_close();
	return TRUE;
}

/**
 * School list
 *
 *   Returns FALSE on error and logs.
 **/
 function db_dept_school_list($selected=NULL,$dbcon=NULL){
require('config/database.config.php');
    $db = $MYSQL['db'];
  // Some checks on the variables being passed
    $db = filter_var($db, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
    $db = filter_var($db, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
  // Prefix checking (If enabled)
	if((isset($MYSQL['prefix']))||($MYSQL['prefix']!="")){
		$prefix = $MYSQL['prefix'];
		$prefix = filter_var($prefix, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
		$prefix = filter_var($prefix, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
	}else{
		$prefix="";
	}
  // Check to see if connection is alive
    if ((!@mysql_ping($dbcon))||($dbcon==NULL)){
		$dbcon = db_connect();
	}
	$db = mysql_select_db($db,$dbcon);
	$query = "SELECT ".$prefix."departments.dept, ".$prefix."school.name, ".$prefix."school.id FROM ".$prefix."departments JOIN ".$prefix."school ON ".$prefix."departments.id=".$prefix."school.deptid ORDER BY ".$prefix."departments.id ASC, ".$prefix."school.id ASC;"; // !!!!!!!!!!!!! SQL QUERY HERE !!!!!!!!!!!!
	$result = @mysql_query($query);
	if (!$result){
		logger("MySQL Error","db_dept_school_list","Database Returned Error - ".mysql_error());
		return 0;
	}
	 while($row = @mysql_fetch_array($result)){
		if($row['id'] == $selected){
			$add = "selected=\"selected\"";
		}else{
			$add = "";
		}
		$list = $list."<option ".$add." value=\"".$row['id']."\">".$row['dept']." - ".$row['name']."</option>";
	}
	mysql_close();
	return $list;
}

/**
 * Delete a Question by id
 *
 * Develop this later to delete any files in the repository that will not be linked anymore.
 *
 *   Returns FALSE on error and logs.
 **/
function db_delete_question($qid,$dbcon=NULL){
require('config/database.config.php');
    $db = $MYSQL['db'];
  // Some checks on the variables being passed
    $db = filter_var($db, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
    $db = filter_var($db, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
  // Prefix checking (If enabled)
	if((isset($MYSQL['prefix']))||($MYSQL['prefix']!="")){
		$prefix = $MYSQL['prefix'];
		$prefix = filter_var($prefix, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
		$prefix = filter_var($prefix, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
	}else{
		$prefix="";
	}  // Check to see if connection is alive
    if ((!@mysql_ping($dbcon))||($dbcon==NULL)){
		$dbcon = db_connect();
	}
	$db = mysql_select_db($db,$dbcon);
	$query = "DELETE FROM ".$prefix."question WHERE `id` = ".$qid.""; // !!!!!!!!!!!!! SQL QUERY HERE !!!!!!!!!!!!
	$result = @mysql_query($query);
	if (!$result){
		logger("MySQL Error","db_delete_question","Database Returned Error - ".mysql_error());
		return 0;
	}
		logger("Delete","db_delete_question","Question id: ".$qid." has been deleted.");
		
	$query2 = "DELETE FROM ".$prefix."response WHERE `qid` = ".$qid.""; // !!!!!!!!!!!!! SQL QUERY HERE !!!!!!!!!!!!
	$result2 = @mysql_query($query2);
	if (!$result2){
		logger("MySQL Error","db_delete_question","Database Returned Error - ".mysql_error());
		return 0;
	}
		logger("Delete","db_delete_question","All Responses for question id: ".$qid." has been deleted.");
	mysql_close();
	return TRUE;
}


/**
 * Delete a response by id
 *
 *   Returns FALSE on error and logs.
 **/
function db_delete_response($id,$dbcon=NULL){
require('config/database.config.php');
    $db = $MYSQL['db'];
  // Some checks on the variables being passed
    $db = filter_var($db, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
    $db = filter_var($db, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
  // Prefix checking (If enabled)
	if((isset($MYSQL['prefix']))||($MYSQL['prefix']!="")){
		$prefix = $MYSQL['prefix'];
		$prefix = filter_var($prefix, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
		$prefix = filter_var($prefix, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
	}else{
		$prefix="";
	}
	$status_orig = status_text($status);
  // Check to see if connection is alive
    if ((!@mysql_ping($dbcon))||($dbcon==NULL)){
		$dbcon = db_connect();
	}
	$db = mysql_select_db($db,$dbcon);
	$query = "DELETE FROM ".$prefix."response WHERE `id` = ".$id.""; // !!!!!!!!!!!!! SQL QUERY HERE !!!!!!!!!!!!
	$result = @mysql_query($query);
	if (!$result){
		logger("MySQL Error","db_delete_response","Database Returned Error - ".mysql_error());
		return 0;
	}
		logger("Delete","db_delete_response","Respponse id: ".$qid." has been deleted.");
	mysql_close();
	return TRUE;
}


/**
 * Change what school a question is in
 *
 *   Returns FALSE on error and logs.
 **/
function db_school_question($qid,$school,$dbcon=NULL){
require('config/database.config.php');
    $db = $MYSQL['db'];
  // Some checks on the variables being passed
    $db = filter_var($db, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
    $db = filter_var($db, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
  // Prefix checking (If enabled)
	if((isset($MYSQL['prefix']))||($MYSQL['prefix']!="")){
		$prefix = $MYSQL['prefix'];
		$prefix = filter_var($prefix, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
		$prefix = filter_var($prefix, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
	}else{
		$prefix="";
	}
  // Check to see if connection is alive
    if ((!@mysql_ping($dbcon))||($dbcon==NULL)){
		$dbcon = db_connect();
	}
	$db = mysql_select_db($db,$dbcon);
	$query = "UPDATE ".$prefix."question SET `dept` = '".$school."'WHERE `id` =".$qid.";"; // !!!!!!!!!!!!! SQL QUERY HERE !!!!!!!!!!!!
	$result = @mysql_query($query);
	if (!$result){
		logger("MySQL Error","db_school_question","Database Returned Error - ".mysql_error());
		return 0;
	}
		logger("School Change","db_school_question","Question id: ".$qid." is now part of ".$school);
	mysql_close();
	return TRUE;
}


/**
 * Campus list
 *
 *   Returns FALSE on error and logs.
 **/
 function db_dept_location_list($selected=NULL,$dbcon=NULL){
require('config/database.config.php');
    $db = $MYSQL['db'];
  // Some checks on the variables being passed
    $db = filter_var($db, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
    $db = filter_var($db, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
  // Prefix checking (If enabled)
	if((isset($MYSQL['prefix']))||($MYSQL['prefix']!="")){
		$prefix = $MYSQL['prefix'];
		$prefix = filter_var($prefix, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
		$prefix = filter_var($prefix, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
	}else{
		$prefix="";
	}
  // Check to see if connection is alive
    if ((!@mysql_ping($dbcon))||($dbcon==NULL)){
		$dbcon = db_connect();
	}
	$db = mysql_select_db($db,$dbcon);
	$query = "SELECT id, location FROM ".$prefix."locations ORDER BY id ASC;"; // !!!!!!!!!!!!! SQL QUERY HERE !!!!!!!!!!!!
	$result = @mysql_query($query);
	if (!$result){
		logger("MySQL Error","db_dept_location_list","Database Returned Error - ".mysql_error());
		return 0;
	}
	 while($row = @mysql_fetch_array($result)){
		if($row['id'] == $selected){
			$add = "selected=\"selected\"";
		}else{
			$add = "";
		}
		$list = $list."<option ".$add." value=\"".$row['id']."\">".$row['location']."</option>";
	}
	mysql_close();
	return $list;
}


/**
 * Retreieve open and pending question ids from the School(Dept in the database) ID
 *
 *  Array
 *   {
 *	  	[id][x]		=> 0123456789
 *   }
 *   Returns FALSE on error and logs.
 **/
function db_problems_gateway_retrieve($dbcon=NULL){
require('config/database.config.php');
    $db = $MYSQL['db'];
  // Some checks on the variables being passed
    $db = filter_var($db, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
    $db = filter_var($db, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
  // Prefix checking (If enabled)
	if((isset($MYSQL['prefix']))||($MYSQL['prefix']!="")){
		$prefix = $MYSQL['prefix'];
		$prefix = filter_var($prefix, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
		$prefix = filter_var($prefix, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
	}else{
		$prefix="";
	}
  // Check to see if connection is alive
    if ((!@mysql_ping($dbcon))||($dbcon==NULL)){
		$dbcon = db_connect();
	}
	$db = mysql_select_db($db,$dbcon);
	$query = "SELECT * FROM ".$prefix."question ORDER BY status ASC, priority DESC,timestamp DESC"; // !!!!!!!!!!!!! SQL QUERY HERE !!!!!!!!!!!!
	$result = @mysql_query($query);
	if (!$result){
		logger("MySQL Error","db_problems_school_retrieve","Database Returned Error - ".mysql_error());
		return 0;
	}
    while($row = @mysql_fetch_array($result)){
		$quest['id'][] = $row['id'];
	}
	mysql_close();
	return $quest;
}

/**
 * Edit Question
 *
 *   Returns FALSE on error and logs.
 **/
function db_question_edit($qid,$message,$priority,$school,$dbcon=NULL){
require('config/database.config.php');
    $db = $MYSQL['db'];
  // Some checks on the variables being passed
    $db = filter_var($db, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
    $db = filter_var($db, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
    $message = htmlspecialchars($message);
  // Prefix checking (If enabled)
	if((isset($MYSQL['prefix']))||($MYSQL['prefix']!="")){
		$prefix = $MYSQL['prefix'];
		$prefix = filter_var($prefix, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
		$prefix = filter_var($prefix, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
	}else{
		$prefix="";
	}
  // Check to see if connection is alive
    if ((!@mysql_ping($dbcon))||($dbcon==NULL)){
		$dbcon = db_connect();
	}
	$db = mysql_select_db($db,$dbcon);
	$query = "UPDATE ".$prefix."question SET `question` = '".$message."', `dept` = '".$school."', `priority` = '".$priority."' WHERE `id` = '".$qid."';"; // !!!!!!!!!!!!! SQL QUERY HERE !!!!!!!!!!!!
	$result = @mysql_query($query);
	if (!$result){
		logger("MySQL Error","db_question_edit","Database Returned Error - ".mysql_error());
		return 0;
	}
		logger("Edit Question","db_question_edit","Question id: ".$qid." has been edited.");
		mysql_close();
	return TRUE;
}


/**
 * Edit Response
 *
 *   Returns FALSE on error and logs.
 **/
function db_response_edit($rid,$message,$dbcon=NULL){
require('config/database.config.php');
    $db = $MYSQL['db'];
  // Some checks on the variables being passed
    $db = filter_var($db, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
    $db = filter_var($db, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
    $message = htmlspecialchars($message);
  // Prefix checking (If enabled)
	if((isset($MYSQL['prefix']))||($MYSQL['prefix']!="")){
		$prefix = $MYSQL['prefix'];
		$prefix = filter_var($prefix, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
		$prefix = filter_var($prefix, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
	}else{
		$prefix="";
	}
  // Check to see if connection is alive
    if ((!@mysql_ping($dbcon))||($dbcon==NULL)){
		$dbcon = db_connect();
	}
	$db = mysql_select_db($db,$dbcon);
	$query = "UPDATE ".$prefix."response SET `response` = '".$message."' WHERE `id` = '".$rid."';"; // !!!!!!!!!!!!! SQL QUERY HERE !!!!!!!!!!!!
	$result = @mysql_query($query);
	if (!$result){
		logger("MySQL Error","db_response_edit","Database Returned Error - ".mysql_error());
		return 0;
	}
		logger("Edit Response","db_response_edit","Response id: ".$rid." has been edited.");
		mysql_close();
	return TRUE;
}


/**
 * Find all FAQ Question ID's
 *  Array
 *   {
 *	  	[id][x]	=> 0123456789
 *   }
 **/
function db_FAQ($dbcon=NULL){
require('config/database.config.php');
    $db = $MYSQL['db'];
  // Some checks on the variables being passed
    $db = filter_var($db, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
    $db = filter_var($db, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
  // Prefix checking (If enabled)
	if((isset($MYSQL['prefix']))||($MYSQL['prefix']!="")){
		$prefix = $MYSQL['prefix'];
		$prefix = filter_var($prefix, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
		$prefix = filter_var($prefix, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
	}else{
		$prefix="";
	}
  // Check to see if connection is alive
    if ((!@mysql_ping($dbcon))||($dbcon==NULL)){
		$dbcon = db_connect();
	}
	$db = mysql_select_db($db,$dbcon);
	$query = "SELECT id FROM ".$prefix."question WHERE `faq` = \"1\""; // !!!!!!!!!!!!! SQL QUERY HERE !!!!!!!!!!!!
	$result = @mysql_query($query);
	if (!$result){
		logger("MySQL Error","db_FAQ","Database Returned Error - ".mysql_error());
		return 0;
	}
	 while($row = @mysql_fetch_array($result)){
		$res['id'][] = $row['id'];
	}
	mysql_close();
  return $res;
}

/**
 * Set Question to FAQ
 *
 *   Returns FALSE on error and logs.
 **/
function db_question_faq($qid,$dbcon=NULL){
require('config/database.config.php');
    $db = $MYSQL['db'];
  // Some checks on the variables being passed
    $db = filter_var($db, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
    $db = filter_var($db, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
  // Prefix checking (If enabled)
	if((isset($MYSQL['prefix']))||($MYSQL['prefix']!="")){
		$prefix = $MYSQL['prefix'];
		$prefix = filter_var($prefix, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
		$prefix = filter_var($prefix, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
	}else{
		$prefix="";
	}
  // Check to see if connection is alive
    if ((!@mysql_ping($dbcon))||($dbcon==NULL)){
		$dbcon = db_connect();
	}
	$db = mysql_select_db($db,$dbcon);
	$query = "UPDATE ".$prefix."question SET `FAQ` = '1' WHERE `id` = '".$qid."';"; // !!!!!!!!!!!!! SQL QUERY HERE !!!!!!!!!!!!
	$result = @mysql_query($query);
	if (!$result){
		logger("MySQL Error","db_question_faq","Database Returned Error - ".mysql_error());
		return 0;
	}
		logger("Edit Question","db_question_faq","Question id: ".$qid." has been made into an FAQ.");
		mysql_close();
	return TRUE;
}


/**
 * Set Question to FAQ
 *
 *   Returns FALSE on error and logs.
 **/
function db_question_unfaq($qid,$dbcon=NULL){
require('config/database.config.php');
    $db = $MYSQL['db'];
  // Some checks on the variables being passed
    $db = filter_var($db, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
    $db = filter_var($db, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
  // Prefix checking (If enabled)
	if((isset($MYSQL['prefix']))||($MYSQL['prefix']!="")){
		$prefix = $MYSQL['prefix'];
		$prefix = filter_var($prefix, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
		$prefix = filter_var($prefix, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
	}else{
		$prefix="";
	}
  // Check to see if connection is alive
    if ((!@mysql_ping($dbcon))||($dbcon==NULL)){
		$dbcon = db_connect();
	}
	$db = mysql_select_db($db,$dbcon);
	$query = "UPDATE ".$prefix."question SET `FAQ` = '0' WHERE `id` = '".$qid."';"; // !!!!!!!!!!!!! SQL QUERY HERE !!!!!!!!!!!!
	$result = @mysql_query($query);
	if (!$result){
		logger("MySQL Error","db_question_unfaq","Database Returned Error - ".mysql_error());
		return 0;
	}
		logger("Edit Question","db_question_unfaq","Question id: ".$qid." has been removed from FAQ.");
		mysql_close();
	return TRUE;
}
?>