<?PHP
/**
 * Staff MySQL Functions
 *
 * These functions have been seperated from the database module as it was getting rather long and hard to find things.
 * There are sections with !!!!!!!!!!!!! SQL QUERY HERE !!!!!!!!!!!! commented on the end of the query, this is so it can be found easily.
 *
 **/

/**
 * Retrieve staff details
 *
 *  Array
 *   {
 *	  	[id]		=> 0123456789
 *	  	[title]		=> Prof.
 *	  	[fname]		=> Tim
 *	  	[sname]		=> Berners-Lee
 *	  	[dept]		=> 15
 *	  	[tel]		=> 01914772000
 *	  	[email]		=> tbl@email.com
 *	  	[group]		=> 3
 *   }
 *   Returns FALSE on error and logs.
 **/
function db_staff_retrieve($id,$dbcon=NULL){
require('config/database.config.php');
    $db = $MYSQL['db'];
  // Some checks on the variables being passed
    $db = filter_var($db, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
    $db = filter_var($db, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
  // Prefix checking (If enabled)
	if((isset($MYSQL['prefix']))||($MYSQL['prefix']!="")){
		$prefix = $MYSQL['prefix'];
		$prefix = filter_var($prefix, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
		$prefix = filter_var($prefix, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
	}else{
		$prefix="";
	}
  // Check to see if connection is alive
    if ((!@mysql_ping($dbcon))||($dbcon==NULL)){
		$dbcon = db_connect();
	}
	$db = mysql_select_db($db,$dbcon);
	$query = "SELECT * FROM ".$prefix."staff WHERE `id` = \"".$id."\""; // !!!!!!!!!!!!! SQL QUERY HERE !!!!!!!!!!!!
	$result = @mysql_query($query);
	if (!$result){
		logger("MySQL Error","db_staff_retrieve","Database Returned Error - ".mysql_error());
		return 0;
	}
 	while($row = @mysql_fetch_array($result)){
		$staff['id'] = $row['id'];
		$staff['title'] = $row['title'];
		$staff['fname'] = $row['fname'];
		$staff['sname'] = $row['sname'];
		$staff['dept'] = $row['dept'];
		$staff['tel'] = $row['tel'];
		$staff['email'] = $row['email'];
		$staff['group'] = $row['group'];
	}
	mysql_close();
	return $staff;
}

/**
 * Retrieve staff Group
 *
 * Returns the Group Name
 * Returns FALSE on error and logs.
 **/
function db_group_retrieve($id,$dbcon=NULL){
require('config/database.config.php');
    $db = $MYSQL['db'];
  // Some checks on the variables being passed
    $db = filter_var($db, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
    $db = filter_var($db, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
  // Prefix checking (If enabled)
	if((isset($MYSQL['prefix']))||($MYSQL['prefix']!="")){
		$prefix = $MYSQL['prefix'];
		$prefix = filter_var($prefix, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
		$prefix = filter_var($prefix, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
	}else{
		$prefix="";
	}
  // Check to see if connection is alive
    if ((!@mysql_ping($dbcon))||($dbcon==NULL)){
		$dbcon = db_connect();
	}
	$db = mysql_select_db($db,$dbcon);
	$query = "SELECT * FROM ".$prefix."staff_groups WHERE `id` = \"".$id."\""; // !!!!!!!!!!!!! SQL QUERY HERE !!!!!!!!!!!!
	$result = @mysql_query($query);
	if (!$result){
		logger("MySQL Error","db_group_retrieve","Database Returned Error - ".mysql_error());
		return 0;
	}
	while($row = @mysql_fetch_array($result)){
		$dept = $row['group'];
	}
	mysql_close();
  return $dept;
}

/**
 * Retrieve staff username
 *
 *   Returns FALSE on error and logs.
 **/
function db_staff_uname_retrieve($id,$dbcon=NULL){
require('config/database.config.php');
    $db = $MYSQL['db'];
  // Some checks on the variables being passed
    $db = filter_var($db, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
    $db = filter_var($db, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
  // Prefix checking (If enabled)
	if((isset($MYSQL['prefix']))||($MYSQL['prefix']!="")){
		$prefix = $MYSQL['prefix'];
		$prefix = filter_var($prefix, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
		$prefix = filter_var($prefix, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
	}else{
		$prefix="";
	}
  // Check to see if connection is alive
    if ((!@mysql_ping($dbcon))||($dbcon==NULL)){
		$dbcon = db_connect();
	}
	$db = mysql_select_db($db,$dbcon);
	$query = "SELECT username FROM ".$prefix."staff_login WHERE `id` = \"".$id."\""; // !!!!!!!!!!!!! SQL QUERY HERE !!!!!!!!!!!!
	$result = @mysql_query($query);
	if (!$result){
		logger("MySQL Error","db_staff_uname_retrieve","Database Returned Error - ".mysql_error());
		return 0;
	}
	while($row = @mysql_fetch_array($result)){
		$name = $row['username'];
	}
	mysql_close();
  return $name;
}


/**
 * School list
 *
 *   Returns FALSE on error and logs.
 **/
 function db_staff_group_list($selected=NULL,$dbcon=NULL){
require('config/database.config.php');
    $db = $MYSQL['db'];
  // Some checks on the variables being passed
    $db = filter_var($db, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
    $db = filter_var($db, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
  // Prefix checking (If enabled)
	if((isset($MYSQL['prefix']))||($MYSQL['prefix']!="")){
		$prefix = $MYSQL['prefix'];
		$prefix = filter_var($prefix, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
		$prefix = filter_var($prefix, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
	}else{
		$prefix="";
	}
  // Check to see if connection is alive
    if ((!@mysql_ping($dbcon))||($dbcon==NULL)){
		$dbcon = db_connect();
	}
	$db = mysql_select_db($db,$dbcon);
	$query = "SELECT id, `group` FROM ".$prefix."staff_groups ORDER BY id ASC;"; // !!!!!!!!!!!!! SQL QUERY HERE !!!!!!!!!!!!
	$result = @mysql_query($query);
	if (!$result){
		logger("MySQL Error","db_dept_school_list","Database Returned Error - ".mysql_error());
		return 0;
	}
	 while($row = @mysql_fetch_array($result)){
		if($row['id'] == $selected){
			$add = "SELECTED";
		}else{
			$add = "";
		}
		$list = $list."<option ".$add." value=\"".$row['id']."\">".$row['group']."</option>";
	}
	mysql_close();
	return $list;
}

/**
 * Add new staff login
 *
 *   Returns FALSE on error and logs.
 **/
function edit_staff_login($id,$pass,$dbcon=NULL){
require('config/database.config.php');
    $db = $MYSQL['db'];
  // Some checks on the variables being passed
    $db = filter_var($db, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
    $db = filter_var($db, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
    $pass = filter_var($pass, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
    $pass = filter_var($pass, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
 // Password encryption process 
	$pass = make_pass($pass);
  // Prefix checking (If enabled)
	if((isset($MYSQL['prefix']))||($MYSQL['prefix']!="")){
		$prefix = $MYSQL['prefix'];
		$prefix = filter_var($prefix, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
		$prefix = filter_var($prefix, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
	}else{
		$prefix="";
	}
  // Check to see if connection is alive
    if ((!@mysql_ping($dbcon))||($dbcon==NULL)){
		$dbcon = db_connect();
	}
	$db = mysql_select_db($db,$dbcon);
	$query = "UPDATE ".$prefix."staff_login SET `password` = '".$pass."' WHERE `id` = '".$id."';"; // !!!!!!!!!!!!! SQL QUERY HERE !!!!!!!!!!!!
	$result = @mysql_query($query);
	if (!$result){
		logger("MySQL Error","edit_staff_login","Database Returned Error - ".mysql_error());
		return 0;
	}
		logger("User","edit_staff_login","User: ".$id." password was edited.");
		logger("Sec","edit_staff_login","User: ".$id." password was edited.");
		logger("Admin","edit_staff_login","User: ".$id." password was edited.");
	mysql_close();
	return TRUE;
}

/**
 * Add new staff details
 *
 *   Returns FALSE on error and logs.
 **/
function edit_staff_details($id,$title,$fname,$sname,$tel,$email,$dbcon=NULL){
require('config/database.config.php');
    $db = $MYSQL['db'];
  // Some checks on the variables being passed
    $db = filter_var($db, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
    $db = filter_var($db, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
    $title = filter_var($title, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
    $title = filter_var($title, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
    $title = ucfirst($title);
    $fname = filter_var($fname, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
    $fname = filter_var($fname, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
    $fname = ucfirst($fname);
    $sname = filter_var($sname, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
    $sname = filter_var($sname, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
    $sname = ucfirst($sname);
  // Prefix checking (If enabled)
	if((isset($MYSQL['prefix']))||($MYSQL['prefix']!="")){
		$prefix = $MYSQL['prefix'];
		$prefix = filter_var($prefix, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
		$prefix = filter_var($prefix, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
	}else{
		$prefix="";
	}
  // Check to see if connection is alive
    if ((!@mysql_ping($dbcon))||($dbcon==NULL)){
		$dbcon = db_connect();
	}
	$db = mysql_select_db($db,$dbcon);
	$query = "UPDATE ".$prefix."staff SET  `title` = '".$title."', `fname` = '".$fname."', `sname` = '".$sname."', `tel` = '".$tel."', `email` = '".$email."' WHERE `id` = '".$id."';"; // !!!!!!!!!!!!! SQL QUERY HERE !!!!!!!!!!!!
	$result = @mysql_query($query);
	if (!$result){
		logger("MySQL Error","edit_staff_details","Database Returned Error - ".mysql_error());
		return 0;
	}
		logger("User","edit_staff_details","User id: ".$id." was edited.");
		logger("Sec","edit_staff_details","User id: ".$id." was edited.");
		logger("Admin","edit_staff_details","User id: ".$id." was edited.");
	mysql_close();
	return TRUE;
}
?>
