<?PHP
/**
 * Student MySQL Functions
 *
 * These functions have been seperated from the database module as it was getting rather long and hard to find things.
 * There are sections with !!!!!!!!!!!!! SQL QUERY HERE !!!!!!!!!!!! commented on the end of the query, this is so it can be found easily.
 *
 **/

/**
 * Retrieve student details
 *
 *  Array
 *   {
 *	  	[id]		=> 0123456789
 *	  	[title]		=> Mr
 *	  	[fname]		=> Jim
 *	  	[sname]		=> Cricket
 *	  	[tel]		=> 01914772000
 *	  	[email]		=> jc@email.com
  *	  	[site]		=> 3
 *   }
 *   Returns FALSE on error and logs.
 **/
function db_student_retrieve($id,$dbcon=NULL){
require('config/database.config.php');
    $db = $MYSQL['db'];
  // Some checks on the variables being passed
    $db = filter_var($db, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
    $db = filter_var($db, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
  // Prefix checking (If enabled)
	if((isset($MYSQL['prefix']))||($MYSQL['prefix']!="")){
		$prefix = $MYSQL['prefix'];
		$prefix = filter_var($prefix, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
		$prefix = filter_var($prefix, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
	}else{
		$prefix="";
	}
  // Check to see if connection is alive
    if ((!@mysql_ping($dbcon))||($dbcon==NULL)){
		$dbcon = db_connect();
	}
	$db = mysql_select_db($db,$dbcon);
	$query = "SELECT * FROM ".$prefix."student WHERE `id` = \"".$id."\""; // !!!!!!!!!!!!! SQL QUERY HERE !!!!!!!!!!!!
	$result = @mysql_query($query);
	if (!$result){
		logger("MySQL Error","db_student_retrieve","Database Returned Error - ".mysql_error());
		return 0;
	}
	while($row = @mysql_fetch_array($result)){
		$student['id'] = $row['id'];
		$student['title'] = $row['title'];
		$student['fname'] = $row['fname'];
		$student['sname'] = $row['sname'];
		$student['tel'] = $row['tel'];
		$student['email'] = $row['email'];
		$student['site'] = $row['site'];
	}
	mysql_close();
  return $student;
}

/**
 * Retrieve student Campus Site
 *
 * This function needs re-written once the site is seperated from the Student Table
 *	once this happens, the output will be the same.
 *
 *  Array
 *   {
 *	  	[site]		=> off
 *	  	[location]	=> London1
 *   }
 *   Returns FALSE on error and logs.
 **/
function db_site_retrieve($id,$dbcon=NULL){
require('config/database.config.php');
    $db = $MYSQL['db'];
  // Some checks on the variables being passed
    $db = filter_var($db, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
    $db = filter_var($db, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
  // Prefix checking (If enabled)
	if((isset($MYSQL['prefix']))||($MYSQL['prefix']!="")){
		$prefix = $MYSQL['prefix'];
		$prefix = filter_var($prefix, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
		$prefix = filter_var($prefix, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
	}else{
		$prefix="";
	}
  // Check to see if connection is alive
    if ((!@mysql_ping($dbcon))||($dbcon==NULL)){
		$dbcon = db_connect();
	}
	$db = mysql_select_db($db,$dbcon);
	$query = "SELECT site FROM ".$prefix."student WHERE `id` = \"".$id."\""; // !!!!!!!!!!!!! SQL QUERY HERE !!!!!!!!!!!!
	$result = @mysql_query($query);
	if (!$result){
		logger("MySQL Error","db_site_retrieve","Database Returned Error - ".mysql_error());
		return 0;
	}
	while($row = @mysql_fetch_array($result)){
		$sites = $row['site'];
	}
	$query = "SELECT location FROM ".$prefix."locations WHERE `id` = \"".$sites."\""; // !!!!!!!!!!!!! SQL QUERY HERE !!!!!!!!!!!!
	$result = @mysql_query($query);
	if (!$result){
		logger("MySQL Error","db_site_retrieve","Database Returned Error - ".mysql_error());
		return 0;
	}
	while($row = @mysql_fetch_array($result)){
		$loc = $row['location'];
	}
	if($sites == 0){
		$site['site'] = "On";
	}else{
		$site['site'] = "Off";
	}
	$site['location'] = $loc;
	mysql_close();
  return $site;
}

/**
 * Retrieve student class
 *
 * This function needs re-written once the education is seperated from the Student Table
 *	once this happens, the output will be the same.
 *
 *  Array
 *   {
 *	  	[level]		=> MSc.
 *	  	[programme]	=> Network Systems
 *   }
 *   Returns FALSE on error and logs.
 **/
function db_course_retrieve($id,$dbcon=NULL){
require('config/database.config.php');
    $db = $MYSQL['db'];
  // Some checks on the variables being passed
    $db = filter_var($db, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
    $db = filter_var($db, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
  // Prefix checking (If enabled)
	if((isset($MYSQL['prefix']))||($MYSQL['prefix']!="")){
		$prefix = $MYSQL['prefix'];
		$prefix = filter_var($prefix, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
		$prefix = filter_var($prefix, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
	}else{
		$prefix="";
	}
  // Check to see if connection is alive
    if ((!@mysql_ping($dbcon))||($dbcon==NULL)){
		$dbcon = db_connect();
	}
	$db = mysql_select_db($db,$dbcon);
	$query = "SELECT level, programme FROM ".$prefix."student WHERE `id` = \"".$id."\""; // !!!!!!!!!!!!! SQL QUERY HERE !!!!!!!!!!!!
	$result = @mysql_query($query);
	if (!$result){
		logger("MySQL Error","db_course_retrieve","Database Returned Error - ".mysql_error());
		return 0;
	}
	while($row = @mysql_fetch_array($result)){
		$lvl = $row['level'];
		$prog = $row['programme'];
	}
	$course['level'] = $lvl;
	$course['programme'] = $prog;
	mysql_close();
  return $course;
}

/**
 * Retrieve student username
 *
 *   Returns FALSE on error and logs.
 **/
function db_student_uname_retrieve($id,$dbcon=NULL){
require('config/database.config.php');
    $db = $MYSQL['db'];
  // Some checks on the variables being passed
    $db = filter_var($db, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
    $db = filter_var($db, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
  // Prefix checking (If enabled)
	if((isset($MYSQL['prefix']))||($MYSQL['prefix']!="")){
		$prefix = $MYSQL['prefix'];
		$prefix = filter_var($prefix, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
		$prefix = filter_var($prefix, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
	}else{
		$prefix="";
	}
  // Check to see if connection is alive
    if ((!@mysql_ping($dbcon))||($dbcon==NULL)){
		$dbcon = db_connect();
	}
	$db = mysql_select_db($db,$dbcon);
	$query = "SELECT username FROM ".$prefix."student_login WHERE `id` = \"".$id."\""; // !!!!!!!!!!!!! SQL QUERY HERE !!!!!!!!!!!!
	$result = @mysql_query($query);
	if (!$result){
		logger("MySQL Error","db_student_uname_retrieve","Database Returned Error - ".mysql_error());
		return 0;
	}
	while($row = @mysql_fetch_array($result)){
		$name = $row['username'];
	}
	mysql_close();
  return $name;
}

/**
 * Add new student login
 *
 *   Returns FALSE on error and logs.
 **/
function edit_student_login($id,$pass,$dbcon=NULL){
require('config/database.config.php');
    $db = $MYSQL['db'];
  // Some checks on the variables being passed
    $db = filter_var($db, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
    $db = filter_var($db, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
    $pass = filter_var($pass, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
    $pass = filter_var($pass, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
 // Password encryption process 
	$pass = make_pass($pass);
  // Prefix checking (If enabled)
	if((isset($MYSQL['prefix']))||($MYSQL['prefix']!="")){
		$prefix = $MYSQL['prefix'];
		$prefix = filter_var($prefix, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
		$prefix = filter_var($prefix, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
	}else{
		$prefix="";
	}
  // Check to see if connection is alive
    if ((!@mysql_ping($dbcon))||($dbcon==NULL)){
		$dbcon = db_connect();
	}
	$db = mysql_select_db($db,$dbcon);
	$query = "UPDATE ".$prefix."student_login SET `password` = '".$pass."' WHERE `id` = '".$id."';"; // !!!!!!!!!!!!! SQL QUERY HERE !!!!!!!!!!!!
	$result = @mysql_query($query);
	if (!$result){
		logger("MySQL Error","edit_student_login","Database Returned Error - ".mysql_error());
		return 0;
	}
		logger("User","edit_student_login","User: ".$id." password was edited.");
		logger("Sec","edit_student_login","User: ".$id." password was edited.");
		logger("Admin","edit_student_login","User: ".$id." password was edited.");
	mysql_close();
	return TRUE;
}

/**
 * Add new student details
 *
 *   Returns FALSE on error and logs.
 **/
function edit_student_details($id,$title,$fname,$sname,$tel,$email,$dbcon=NULL){
require('config/database.config.php');
    $db = $MYSQL['db'];
  // Some checks on the variables being passed
    $db = filter_var($db, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
    $db = filter_var($db, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
    $title = filter_var($title, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
    $title = filter_var($title, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
    $title = ucfirst($title);
    $fname = filter_var($fname, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
    $fname = filter_var($fname, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
    $fname = ucfirst($fname);
    $sname = filter_var($sname, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
    $sname = filter_var($sname, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
    $sname = ucfirst($sname);
  // Prefix checking (If enabled)
	if((isset($MYSQL['prefix']))||($MYSQL['prefix']!="")){
		$prefix = $MYSQL['prefix'];
		$prefix = filter_var($prefix, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_LOW);
		$prefix = filter_var($prefix, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
	}else{
		$prefix="";
	}
  // Check to see if connection is alive
    if ((!@mysql_ping($dbcon))||($dbcon==NULL)){
		$dbcon = db_connect();
	}
	$db = mysql_select_db($db,$dbcon);
	$query = "UPDATE ".$prefix."student SET  `title` = '".$title."', `fname` = '".$fname."', `sname` = '".$sname."', `tel` = '".$tel."', `email` = '".$email."' WHERE `id` = '".$id."';"; // !!!!!!!!!!!!! SQL QUERY HERE !!!!!!!!!!!!
	$result = @mysql_query($query);
	if (!$result){
		logger("MySQL Error","edit_student_details","Database Returned Error - ".mysql_error());
		return 0;
	}
		logger("User","edit_student_details","User id: ".$id." was edited.");
		logger("Sec","edit_student_details","User id: ".$id." was edited.");
		logger("Admin","edit_student_details","User id: ".$id." was edited.");
	mysql_close();
	return TRUE;
}
?>
